import aoclib


inp = aoclib.get_input(1, parser=aoclib.group_on_empty_line(casting_func=int))


def part1():
    lorge = 0
    for group in inp:
        c = sum(group)
        if c > lorge:
            lorge = c

    return lorge


def part2():
    sums = []
    for group in inp:
        sums.append(sum(group))
    return sum(list(reversed(sorted(sums)))[:3])


aoclib.main(part1, part2)
